const { Gio } = imports.gi

// Copied from https://github.com/GSConnect/gnome-shell-extension-gsconnect/blob/80c3d156fbc61c97d3a3a004172f41056d8ff316/src/shell/utils.js

// eslint-disable-next-line no-unused-vars
function getIcon(name) {
  log('GetIcon: ' + name)
  if (getIcon._resource === undefined) {
    // Setup the desktop icons
    const settings = imports.gi.St.Settings.get()
    getIcon._desktop = new imports.gi.Gtk.IconTheme()
    getIcon._desktop.set_custom_theme(settings.gtk_icon_theme)
    settings.connect('notify::gtk-icon-theme', (settings_) => {
      getIcon._desktop.set_custom_theme(settings_.gtk_icon_theme)
    })

    // Preload our fallbacks
    const iconPath =
      'resource://org/gnome/Shell/Extensions/WarpQuickSettings/icons'
    const iconNames = [
      'org.gnome.Shell.Extensions.WarpQuickSettings.CloudflareLogo',
    ]

    getIcon._resource = {}

    for (const iconName of iconNames) {
      getIcon._resource[iconName] = new Gio.FileIcon({
        file: Gio.File.new_for_uri(`${iconPath}/${iconName}.svg`),
      })
    }
  }

  if (getIcon._desktop.has_icon(name)) return new Gio.ThemedIcon({ name: name })

  if (getIcon._resource[name] !== undefined) return getIcon._resource[name]

  return new Gio.ThemedIcon({ name: name })
}
